#!/usr/bin/php -q
<?php

require_once('../Text/LogSplitter.php');

class Test_Text_LogSplitter extends Text_LogSplitter
{
	var $output = array();
	
	function _outputLine($base_host, $line)
	{
		$this->output[] = $base_host.':'.$line;
	}
}

$splitter = new Test_Text_LogSplitter('test.ini');
$splitter->run();

$correct_output = array(
	'www.example.com:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test1 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'www.example.net:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test2 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'www.example.net:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test3 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'unknown:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET http://invalid.example.org/test4 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'www.example.net:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test4 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'unknown:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET http://evil..*example/test4/test HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'www.example.com:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test7 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
	'www.example.com:1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test8 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request" TCP_IMS_HIT:NONE',
);

print "Squid:";
if ($splitter->output === $correct_output) {
	print "PASS\n";
} else {
	print "FAIL\n";
	var_dump($correct_output);
	var_dump($splitter->output);
}


print "Pound:";
foreach($correct_output as $id => $line) {
	$correct_output[$id] = str_replace(' TCP_IMS_HIT:NONE','',$line);
}
$correct_output[3] = 'unknown:Oct 30 21:11:55 machine1 pound: invalid.example.org 1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test4 HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request"';
$correct_output[5] = 'unknown:Oct 30 21:11:55 machine1 pound: evil..*example/test4 1.2.3.4 - - [30/Oct/2006:21:11:55 +0000] "GET /test HTTP/1.0" 304 377 "-" "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0) Active Cache Request"';
$splitter = new Test_Text_LogSplitter('test-pound.ini');
$splitter->run();

if ($splitter->output === $correct_output) {
	print "PASS\n";
} else {
	print "FAIL\n";
	print "correct:\n";
	var_dump($correct_output);
	print "received:\n";
	var_dump($splitter->output);
}

?>
